﻿using Readers;
using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Runtime.InteropServices.ComTypes;
using System.Text;

namespace Kivii.Client.SampleAssigns
{
    public class ReaderExtension
    {
        public static string FormatErrorCode(byte btErrorCode)
        {
            string strErrorCode = "";
            switch (btErrorCode)
            {
                case 0x10:
                    strErrorCode = "命令已执行";
                    break;
                case 0x11:
                    strErrorCode = "命令执行失败";
                    break;
                case 0x20:
                    strErrorCode = "CPU 复位错误";
                    break;
                case 0x21:
                    strErrorCode = "打开CW 错误";
                    break;
                case 0x22:
                    strErrorCode = "天线未连接";
                    break;
                case 0x23:
                    strErrorCode = "写Flash 错误";
                    break;
                case 0x24:
                    strErrorCode = "读Flash 错误";
                    break;
                case 0x25:
                    strErrorCode = "设置发射功率错误";
                    break;
                case 0x31:
                    strErrorCode = "盘存标签错误";
                    break;
                case 0x32:
                    strErrorCode = "读标签错误";
                    break;
                case 0x33:
                    strErrorCode = "写标签错误";
                    break;
                case 0x34:
                    strErrorCode = "锁定标签错误";
                    break;
                case 0x35:
                    strErrorCode = "灭活标签错误";
                    break;
                case 0x36:
                    strErrorCode = "无可操作标签错误";
                    break;
                case 0x37:
                    strErrorCode = "成功盘存但访问失败";
                    break;
                case 0x38:
                    strErrorCode = "缓存为空";
                    break;
                case 0x40:
                    strErrorCode = "访问标签错误或访问密码错误";
                    break;
                case 0x41:
                    strErrorCode = "无效的参数";
                    break;
                case 0x42:
                    strErrorCode = "wordCnt 参数超过规定长度";
                    break;
                case 0x43:
                    strErrorCode = "MemBank 参数超出范围";
                    break;
                case 0x44:
                    strErrorCode = "Lock 数据区参数超出范围";
                    break;
                case 0x45:
                    strErrorCode = "LockType 参数超出范围";
                    break;
                case 0x46:
                    strErrorCode = "读卡器地址无效";
                    break;
                case 0x47:
                    strErrorCode = "Antenna_id 超出范围";
                    break;
                case 0x48:
                    strErrorCode = "输出功率参数超出范围";
                    break;
                case 0x49:
                    strErrorCode = "射频规范区域参数超出范围";
                    break;
                case 0x4A:
                    strErrorCode = "波特率参数超过范围";
                    break;
                case 0x4B:
                    strErrorCode = "蜂鸣器设置参数超出范围";
                    break;
                case 0x4C:
                    strErrorCode = "EPC 匹配长度越界";
                    break;
                case 0x4D:
                    strErrorCode = "EPC 匹配长度错误";
                    break;
                case 0x4E:
                    strErrorCode = "EPC 匹配参数超出范围";
                    break;
                case 0x4F:
                    strErrorCode = "频率范围设置参数错误";
                    break;
                case 0x50:
                    strErrorCode = "无法接收标签的RN16";
                    break;
                case 0x51:
                    strErrorCode = "DRM 设置参数错误";
                    break;
                case 0x52:
                    strErrorCode = "PLL 不能锁定";
                    break;
                case 0x53:
                    strErrorCode = "射频芯片无响应";
                    break;
                case 0x54:
                    strErrorCode = "输出达不到指定的输出功率";
                    break;
                case 0x55:
                    strErrorCode = "版权认证未通过";
                    break;
                case 0x56:
                    strErrorCode = "频谱规范设置错误";
                    break;
                case 0x57:
                    strErrorCode = "输出功率过低";
                    break;
                case 0xFF:
                    strErrorCode = "未知错误";
                    break;

                default:
                    break;
            }

            return strErrorCode;
        }

        /// <summary>
        /// 16进制字符数组转成字符串
        /// </summary>
        /// <param name="btAryHex"></param>
        /// <param name="nIndex"></param>
        /// <param name="nLen"></param>
        /// <returns></returns>
        public static string ByteArrayToString(byte[] btAryHex, int nIndex, int nLen)
        {
            if (nIndex + nLen > btAryHex.Length)
            {
                nLen = btAryHex.Length - nIndex;
            }

            string strResult = string.Empty;

            for (int nloop = nIndex; nloop < nIndex + nLen; nloop++)
            {
                string strTemp = string.Format(" {0:X2}", btAryHex[nloop]);

                strResult += strTemp;
            }

            return strResult;
        }

        public static void ProcessSetWorkAntenna(MessageTran msgTran,Reader reader, InventoryBuffer buffer, ReaderSetting setting,bool m_bInventory)
        {
            int intCurrentAnt = 0;
            intCurrentAnt = setting.btWorkAntenna + 1;
            string strCmd = "设置工作天线成功,当前工作天线: 天线" + intCurrentAnt.ToString();

            string strErrorCode = string.Empty;

            if (msgTran.AryData.Length == 1)
            {
                if (msgTran.AryData[0] == 0x10)
                {
                    setting.btReadId = msgTran.ReadId;
                    //WriteLog(logRichTxt, strCmd, 0);

                    //校验是否盘存操作
                    if (m_bInventory)
                    {
                        RunLoopInventroy(reader,buffer,setting);
                    }
                    return;
                }
                else
                {
                    strErrorCode = FormatErrorCode(msgTran.AryData[0]);
                }
            }
            else
            {
                strErrorCode = "未知错误";
            }

            string strLog = strCmd + "失败，失败原因： " + strErrorCode;
            //WriteLog(logRichTxt, strLog, 1);

            if (m_bInventory)
            {
                buffer.nCommond = 1;
                buffer.dtEndInventory = DateTime.Now;
                RunLoopInventroy(reader,buffer, setting);
            }
        }

        public static void RunLoopInventroy(Reader reader,InventoryBuffer buffer,ReaderSetting setting)
        {
            //校验盘存是否所有天线均完成
            if (buffer.nIndexAntenna < buffer.lAntenna.Count - 1 || buffer.nCommond == 0)
            {
                if (buffer.nCommond == 0)
                {
                    buffer.nCommond = 1;

                    if (buffer.bLoopInventoryReal)
                    {
                        //m_bLockTab = true;
                        //btnInventory.Enabled = false;
                        if (buffer.bLoopCustomizedSession)//自定义Session和Inventoried Flag 
                        {
                            reader.CustomizedInventory(setting.btReadId, buffer.btSession, buffer.btTarget, buffer.btRepeat);
                        }
                        else //实时盘存
                        {
                            reader.InventoryReal(setting.btReadId, buffer.btRepeat);

                        }
                    }
                    else
                    {
                        if (buffer.bLoopInventory)
                            reader.Inventory(setting.btReadId, buffer.btRepeat);
                    }
                }
                else
                {
                    buffer.nCommond = 0;
                    buffer.nIndexAntenna++;

                    byte btWorkAntenna = buffer.lAntenna[buffer.nIndexAntenna];
                    reader.SetWorkAntenna(setting.btReadId, btWorkAntenna);
                    setting.btWorkAntenna = btWorkAntenna;
                }
            }
            //校验是否循环盘存
            else if (buffer.bLoopInventory)
            {
                buffer.nIndexAntenna = 0;
                buffer.nCommond = 0;

                byte btWorkAntenna = buffer.lAntenna[buffer.nIndexAntenna];
                reader.SetWorkAntenna(setting.btReadId, btWorkAntenna);
                setting.btWorkAntenna = btWorkAntenna;
            }
        }

        public static string ProcessReadTag(MessageTran msgTran, Reader reader, InventoryBuffer buffer, ReaderSetting setting,out string epc)
        {
            string strErrorCode = string.Empty;
            epc = string.Empty;
            if (msgTran.AryData.Length == 1)
            {
                strErrorCode = FormatErrorCode(msgTran.AryData[0]);
                return string.Empty;
            }
            else
            {
                int nLen = msgTran.AryData.Length;
                int nDataLen = Convert.ToInt32(msgTran.AryData[nLen - 3]);
                int nEpcLen = Convert.ToInt32(msgTran.AryData[2]) - nDataLen - 4;

                string strPC = ByteArrayToString(msgTran.AryData, 3, 2);
                string strEPC = ByteArrayToString(msgTran.AryData, 5, nEpcLen);
                string strCRC = ByteArrayToString(msgTran.AryData, 5 + nEpcLen, 2);
                string strTid = ByteArrayToString(msgTran.AryData, 7 + nEpcLen, nDataLen);

                byte byTemp = msgTran.AryData[nLen - 2];
                byte byAntId = (byte)((byTemp & 0x03) + 1);
                string strAntId = byAntId.ToString();

                string strReadCount = msgTran.AryData[nLen - 1].ToString();

                DataRow row = buffer.dtTagTable.NewRow();
                row[0] = strPC;
                row[1] = strCRC;
                row[2] = strEPC;
                row[3] = strTid;
                row[4] = nDataLen.ToString();
                row[5] = strAntId;
                row[6] = strReadCount;

                buffer.dtTagTable.Rows.Add(row);
                buffer.dtTagTable.AcceptChanges();
                if (!strEPC.IsNullOrEmpty()) epc = strEPC.Replace(" ", "");

                if (!strTid.IsNullOrEmpty()) return strTid.Replace(" ", "");
                return string.Empty;
            }
        }

        public static string ProcessInventoryReal(MessageTran msgTran, Reader reader, InventoryBuffer buffer, ReaderSetting setting)
        {
            if (msgTran.AryData.Length == 1)
            {
                RunLoopInventroy(reader,buffer,setting);
                return string.Empty;
            }
            else if (msgTran.AryData.Length == 7)
            {
                buffer.nReadRate = Convert.ToInt32(msgTran.AryData[1]) * 256 + Convert.ToInt32(msgTran.AryData[2]);
                buffer.nDataCount = Convert.ToInt32(msgTran.AryData[3]) * 256 * 256 * 256 + Convert.ToInt32(msgTran.AryData[4]) * 256 * 256 + Convert.ToInt32(msgTran.AryData[5]) * 256 + Convert.ToInt32(msgTran.AryData[6]);

                RunLoopInventroy(reader, buffer, setting);
                return string.Empty;
            }
            else
            {

                int nLength = msgTran.AryData.Length;
                int nEpcLength = nLength - 4;

                //int nDataLen = Convert.ToInt32(msgTran.AryData[nLength - 3]);
                //int nEpcLen = Convert.ToInt32(msgTran.AryData[2]) - nDataLen - 4;


                string strEPC = ByteArrayToString(msgTran.AryData, 3, nEpcLength);
                string strPC = ByteArrayToString(msgTran.AryData, 1, 2);
                //string strTid = ByteArrayToString(msgTran.AryData, 7 + nEpcLen, nDataLen);

                string strRSSI = msgTran.AryData[nLength - 1].ToString();
                SetMaxMinRSSI(Convert.ToInt32(msgTran.AryData[nLength - 1]), buffer);
                byte btTemp = msgTran.AryData[0];
                byte btAntId = (byte)((btTemp & 0x03) + 1);
                buffer.nCurrentAnt = btAntId;
                string strAntId = btAntId.ToString();

                byte btFreq = (byte)(btTemp >> 2);
                string strFreq = GetFreqString(btFreq, setting);
                DataRow[] drs = buffer.dtTagTable.Select(string.Format("COLEPC = '{0}'", strEPC));
                if (drs.Length == 0)
                {
                    DataRow row1 = buffer.dtTagTable.NewRow();
                    row1[0] = strPC;
                    row1[2] = strEPC;
                    row1[4] = strRSSI;
                    row1[5] = "1";
                    row1[6] = strFreq;
                    //row1[7] = strTid;

                    buffer.dtTagTable.Rows.Add(row1);
                    buffer.dtTagTable.AcceptChanges();
                }
                else
                {
                    foreach (DataRow dr in drs)
                    {
                        dr.BeginEdit();

                        dr[4] = strRSSI;
                        dr[5] = (Convert.ToInt32(dr[5]) + 1).ToString();
                        dr[6] = strFreq;

                        dr.EndEdit();
                    }
                    buffer.dtTagTable.AcceptChanges();
                }

                buffer.dtEndInventory = DateTime.Now;
                return RefreshInventoryReal(0x89, buffer);
            }
        }

        internal static void SetMaxMinRSSI(int nRSSI, InventoryBuffer buffer)
        {
            if (buffer.nMaxRSSI < nRSSI)
            {
                buffer.nMaxRSSI = nRSSI;
            }

            if (buffer.nMinRSSI == 0)
            {
                buffer.nMinRSSI = nRSSI;
            }
            else if (buffer.nMinRSSI > nRSSI)
            {
                buffer.nMinRSSI = nRSSI;
            }
        }

        internal static string GetFreqString(byte btFreq, ReaderSetting setting)
        {
            string strFreq = string.Empty;

            if (setting.btRegion == 4)
            {
                float nExtraFrequency = btFreq * setting.btUserDefineFrequencyInterval * 10;
                float nstartFrequency = ((float)setting.nUserDefineStartFrequency) / 1000;
                float nStart = nstartFrequency + nExtraFrequency / 1000;
                string strTemp = nStart.ToString("0.000");
                return strTemp;
            }
            else
            {
                if (btFreq < 0x07)
                {
                    float nStart = 865.00f + Convert.ToInt32(btFreq) * 0.5f;

                    string strTemp = nStart.ToString("0.00");

                    return strTemp;
                }
                else
                {
                    float nStart = 902.00f + (Convert.ToInt32(btFreq) - 7) * 0.5f;

                    string strTemp = nStart.ToString("0.00");

                    return strTemp;
                }
            }
        }

        public static string RefreshInventoryReal(byte btCmd,InventoryBuffer buffer)
        {
            if (btCmd != 0x89) return string.Empty;
            int nTagCount = buffer.dtTagTable.Rows.Count;

            //////列表用变量
            //int nEpcCount = _currentEpcs.Count + _currentEpcErrs.Count;
            int nEpcLength = buffer.dtTagTable.Rows.Count;

            //if (nEpcCount < nEpcLength)
            //{
            DataRow row = buffer.dtTagTable.Rows[nEpcLength - 1];
            return row[2].ToString().Replace(" ", "");
        }
    }

}

